#!/usr/local/php512/bin/php
<?
/***************************************************************************
 *   Copyright (C) 2005 by Ferenc Veres   *
 *   lion@netngine.hu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
if(empty($argc))
{
	exit;
}
include_once('QtBackend.php');

if(!extension_loaded('php_qt')) {
	dl('php_qt.so');
}

class MainWindow extends QWidget
{
	// Main window stuff
	public $layMain;	// Vertical layout

	// Translator text controls
	public $txtOriginal;
	public $txtTranslation;
	public $lblOriginal;
	public $lblTranslation;

	// Translator buttons
	public $btnQuit;
	public $btnPrev;
	public $btnNext;
	public $btnOKNext;
	public $wButtons;	// Placholder for translator buttons.
	public $layButtons;

	// Guess controls
	public $sldPercent;
	public $lcdPercent;
	public $btnRefresh;
	public $wGuessControls;	// Placholder for guess controls.
	public $layGuessControls;

	// Guess text fields
	public $txtGuessPercents;
	public $txtGuessOriginals;
	public $txtGuessTranslations;
	public $btnGuessTake;
	public $layGrid;

	function __construct()
	{
		parent::__construct();

		$this->resize(600,500);
		$maxGuesses = 9;

		$this->layMain = new QVBoxLayout($this);

		// Translator input fields
		$this->txtOriginal = new QLineEdit("This will be the place for the English text.", $this);
		$this->layMain->addWidget($this->txtOriginal);
		//$mystr = new QString("alma");
		//$this->lblOriginal = new QLabel("hello", $this);
		//$this->lblOriginal = new QLabel($this);
		//$this->lblOriginal = new QLabel($mystr, $this);
		//$this->lblOriginal->setText("helllo");
		//print_r($this->lblOriginal);
		//$this->layMain->addWidget($this->lblOriginal);

		$this->txtTranslation = new QLineEdit("Translation comes here", $this);
		$this->layMain->addWidget($this->txtTranslation);

		// Translator buttons
		$this->wButtons = new QWidget();
		$this->layButtons = new QHBoxLayout($this->wButtons);
		$this->wButtons->setLayout($this->layButtons);
		
		$this->btnOKNext = new QPushButton("OK + Next", $this->wButtons);
		$this->layButtons->addWidget($this->btnOKNext);

		$this->btnPrev = new QPushButton("Previous", $this->wButtons);
		$this->layButtons->addWidget($this->btnPrev);
		
		$this->btnNext = new QPushButton("Next", $this->wButtons);
		$this->layButtons->addWidget($this->btnNext);

		$this->layButtons->addStretch(1);

		$this->btnQuit = new QPushButton("Quit", $this->wButtons);
		$this->layButtons->addWidget($this->btnQuit);
		
		// Events for translator buttons
		$this->connect($this->btnQuit, SIGNAL("clicked()"), QApplication::instance(), SLOT("quit()"));
		$this->connect($this->btnNext, SIGNAL("clicked()"), $this, SLOT("btnNext_Clicked()"));
		//$this->connect($this->btnNext, SIGNAL("clicked()"), QApplication::instance(), SLOT("aboutQt()"));

		// Guess controls
		$this->wGuessControls = new QWidget();
		$this->sldPercent = new QSlider($this->wGuessControls);
		$this->sldPercent->setOrientation(QT_ORIENTATIONS_HORIZONTAL);
		$this->sldPercent->setRange(0, 99);
		$this->sldPercent->setValue(50);
		$this->lcdPercent = new QLCDNumber(2, $this->wGuessControls);
		$this->lcdPercent->value(50);
		$this->btnRefresh = new QPushButton("Refresh", $this->wGuessControls);

		// Layout guess controls
		$this->layGuessControls = new QHBoxLayout($this->wGuessControls);
		$this->layGuessControls->addWidget($this->sldPercent);
		$this->layGuessControls->addWidget($this->lcdPercent);
		$this->layGuessControls->addWidget($this->btnRefresh);

		$this->layGrid = new QGridLayout();
		// Guess fields
		for($i = 0; $i < $maxGuesses; $i++)
		{
			// Guess fields widgets
			$this->txtGuessPercents[$i] = new QLineEdit("", $this);
			$this->txtGuessOriginals[$i] = new QLineEdit("", $this);
			$this->txtGuessTranslations[$i] = new QLineEdit("", $this);
			$this->btnGuessTake[$i] = new QPushButton("^", $this);

			// Guess fields layout
			$this->layGrid->addWidget($this->txtGuessPercents[$i], $i, 0, 0);
			$this->layGrid->addWidget($this->txtGuessOriginals[$i], $i, 1, 0);
			$this->layGrid->addWidget($this->txtGuessTranslations[$i], $i, 2, 0);
			$this->layGrid->addWidget($this->btnGuessTake[$i], $i, 3, 0);
		}

		// Event connections
		$this->connect($this->sldPercent, SIGNAL("valueChanged(int)"),$this->lcdPercent, SLOT("display(int)"));

		$this->layMain->addWidget($this->wButtons);
		$this->layMain->addLayout($this->layGrid);
		$this->layMain->addWidget($this->wGuessControls);


		$this->setLayout($this->layMain);

		$this->JustTest();
	}

	function btnNext_Clicked()
	{
		echo "here we go";
		QApplication::instance()->aboutQt();
		//$this->Application->aboutQt();
	}

	function JustTest()
	{
	
		$findText = "Delete All";
		$filterPercent = 60;
	
		//echo("SEEK: $findText\n");
		// Upload this sentence to our $Sentence class
		$str = new TranslationString();
		$translations = $str->FindSimilar($findText, $filterPercent);
	
		if(empty($translations))
		{
			echo("nothing similar, sorry.\n");
			return;
		}
		
		$i = 0;
		foreach($translations as $id => $tr)
		{
			foreach($tr["strings"] as $key => $str)
			{
				//echo($tr["percent"]."%\n");
				//echo("   >>> '".$str->GetOriginal()."' === '".$str->GetTranslation()."'\n");
				if($i < 9)
				{
					$this->txtGuessPercents[$i]->setText($tr["percent"]."%");
					//echo $this->txtGuessPercents[$i]->$text;
					$this->txtGuessOriginals[$i]->setText($str->GetOriginal());
					//$txt = new QString($str->GetTranslation());
					//echo "NA:".$txt->toUtf8();
					//$txt = new QString("aa");
					//$txt->toUtf8();
					//$this->txtGuessTranslations[$i]->setText($txt);
					$this->txtGuessTranslations[$i]->setText($str->GetTranslation());
				}
				$i++;
			}
		}

	}

}


$app = new QApplication();
$widget = new MainWindow();
$widget->show();

$app->exec();

?>
